<?php session_start();
/*      Copyright 2023 Flávio Ribeiro

        This file is part of OCOMON.

        OCOMON is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 3 of the License, or
        (at your option) any later version.
        OCOMON is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with Foobar; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if (!isset($_SESSION['s_logado']) || $_SESSION['s_logado'] == 0) {
    $_SESSION['session_expired'] = 1;
    echo "<script>top.window.location = '../../index.php'</script>";
    exit;
}

require_once __DIR__ . "/" . "../../includes/include_basics_only.php";
require_once __DIR__ . "/" . "../../includes/classes/ConnectPDO.php";

use includes\classes\ConnectPDO;

$conn = ConnectPDO::getInstance();

$post = $_POST;

$exception = "";
$screenNotification = "";
$entity = "impact_factors";
$ticket_field = "impact_factor";
$data = [];
$data['success'] = true;
$data['message'] = "";
$data['cod'] = (isset($post['cod']) ? intval($post['cod']) : "");
$data['action'] = $post['action'];
$data['field_id'] = "";
$data['csrf_session_key'] = (isset($post['csrf_session_key']) ? $post['csrf_session_key'] : "");


$data['factor_name'] = (isset($post['factor_name']) && !empty($post['factor_name']) ? noHtml($post['factor_name']) : "");
$data['factor'] = (isset($post['factor_value']) ? floatval($post['factor_value']) : "");

if (!empty($data['factor']) && (!is_numeric($data['factor']) || $data['factor'] < 0)) {
    $data['success'] = false; 
    $data['field_id'] = "factor_value";
    $data['message'] = message('warning', 'Ooops!', TRANS('MSG_ERROR_WRONG_FORMATTED'),'');
    echo json_encode($data);
    return false;
}

/* Validações */
if ($data['action'] == "new" || $data['action'] == "edit") {

    if (empty($data['factor_name'])) {
        $data['success'] = false; 
        $data['field_id'] = "factor_name";
    }
    if (empty($data['factor'])) {
        $data['success'] = false; 
        $data['field_id'] = "factor_value";
    }

    if ($data['success'] == false) {
        $data['message'] = message('warning', 'Ooops!', TRANS('MSG_EMPTY_DATA'),'');
        echo json_encode($data);
        return false;
    }
}


if ($data['action'] == 'new') {

    /* verifica se um registro com esse nome já existe */
    $sql = "SELECT id FROM {$entity} WHERE `name` = '{$data['factor_name']}' OR factor = '{$data['factor']}'";
    $res = $conn->query($sql);
    if ($res->rowCount()) {
        $data['success'] = false; 
        $data['field_id'] = "factor_name";
        $data['message'] = message('warning', '', TRANS('MSG_RECORD_EXISTS_WITH_NAME_OR_FACTOR'), '');
        echo json_encode($data);
        return false;
    }


    if (!csrf_verify($post, $data['csrf_session_key'])) {
        $data['success'] = false; 
        $data['message'] = message('warning', 'Ooops!', TRANS('FORM_ALREADY_SENT'),'');
    
        echo json_encode($data);
        return false;
    }

    $sql = "INSERT INTO {$entity} 
        (
            `name`, 
            factor
        ) 
        VALUES 
        (
            :factor_name, 
            :factor
        )";

    try {
        $res = $conn->prepare($sql);
        $res->bindParam(':factor_name', $data['factor_name'], PDO::PARAM_STR);
        $res->bindParam(':factor', $data['factor']);
        $res->execute();

        $data['success'] = true; 
        $data['message'] = TRANS('MSG_SUCCESS_INSERT');
        $_SESSION['flash'] = message('success', '', $data['message'], '');
        echo json_encode($data);
        return false;
    } catch (Exception $e) {
        $exception .= "<hr>" . $e->getMessage();
        $data['success'] = false; 
        $data['message'] = TRANS('MSG_ERR_SAVE_RECORD') . $exception;
        $_SESSION['flash'] = message('danger', '', $data['message'], '');
        echo json_encode($data);
        return false;
    }

} elseif ($data['action'] == 'edit') {

    /* verifica se um registro com esse nome ou factor já existe para outro código */
    $sql = "SELECT id FROM {$entity} WHERE (`name` = '{$data['factor_name']}' OR factor = '{$data['factor']}') AND id <> {$data['cod']}";
    $res = $conn->query($sql);
    if ($res->rowCount()) {
        $data['success'] = false; 
        $data['field_id'] = "factor_name";
        $data['message'] = message('warning', '', TRANS('MSG_RECORD_EXISTS_WITH_NAME_OR_FACTOR'), '');
        echo json_encode($data);
        return false;
    }

    if (!csrf_verify($post, $data['csrf_session_key'])) {
        $data['success'] = false; 
        $data['message'] = message('warning', 'Ooops!', TRANS('FORM_ALREADY_SENT'),'');
    
        echo json_encode($data);
        return false;
    }

    $sql = "UPDATE {$entity} SET 
				`name` = :factor_name, 
				factor = :factor 
            WHERE id = {$data['cod']}";

    try {
        $res = $conn->prepare($sql);
        $res->bindParam(':factor_name', $data['factor_name']);
        $res->bindParam(':factor', $data['factor']);
        $res->execute();
        
        $data['success'] = true; 
        $data['message'] = TRANS('MSG_SUCCESS_EDIT');
        $_SESSION['flash'] = message('success', '', $data['message'], '');
        echo json_encode($data);
        return false;
    } catch (Exception $e) {
        $exception .= "<hr>" . $e->getMessage();
        $data['success'] = false; 
        $data['message'] = TRANS('MSG_ERR_DATA_UPDATE') . $exception;
        $_SESSION['flash'] = message('danger', '', $data['message'], '');
        echo json_encode($data);
        return false;
    }

} elseif ($data['action'] == 'delete') {

    $sqlFindPrevention = "SELECT * FROM ocorrencias WHERE {$ticket_field} = {$data['cod']}";
    $resFindPrevention = $conn->query($sqlFindPrevention);
    $foundPrevention = $resFindPrevention->rowCount();

    if ($foundPrevention) {
        $data['success'] = false; 
        $data['message'] = TRANS('MSG_CANT_DEL');
        $_SESSION['flash'] = message('danger', '', $data['message'], '');
        echo json_encode($data);
        return false;
    }
    

    $sql = "DELETE FROM {$entity} WHERE id = {$data['cod']}";

    try {
        $conn->exec($sql);
        $data['success'] = true; 
        $data['message'] = TRANS('OK_DEL');
        $_SESSION['flash'] = message('success', '', $data['message'], '');
        echo json_encode($data);
        return false;
    } catch (Exception $e) {
        $exception .= "<hr>" . $e->getMessage();
        $data['success'] = false; 
        $data['message'] = TRANS('MSG_ERR_DATA_REMOVE');
        $_SESSION['flash'] = message('danger', '', $data['message'] . $exception, '');
        echo json_encode($data);
        return false;
    }
    
}

echo json_encode($data);